Subject: Re: git clone and submodules

From: Jens Lehmann <[email-masked]>
Date: Thu, 16 Jun 2011 20:02:46 +0200

Am 16.06.2011 15:13, schrieb Massimo Manca:
> 2. RepoWR will contain a complex project developed by several engineers
> and made of some subprojects (already existent) and some libraries. I
> would manage them as submodules, these are my intents:
> a) the library mclib (about 50 c files) has its repo on a different
> location, I would "connect" its repo inside RepoWR as a submodule
> because I am sure that we need to modify/extend the library and we would
> to have the ability to modify it and propagate modifications to its
> repo, forcing all users of mclib to see the modifications and to repeate
> their regression tests

That sounds like submodules would fit in nicely here.

> How can implement this situation? Where can I find info or documentation?

http://progit.org/book/ch6-6.html
http://www.kernel.org/pub/software/scm/git/docs/user-manual.html#submodules

And for questions not answered there feel free to ask.

> b) every module (not more the 4-5 c files) will be developed and unit
> tested, so normally every engineer makes a unit test project
> implementing/using the module to test with TDD workflow. During the
> progress of the work the modules must be added and committed to RepoWR;
> the modules are on the working directory of RepoWR (RepoWR\src) and the
> test files on a specific subfolder (RepoWR\TestModuleOne\src).
> Is this a viable solution or are there hidden problems and so better
> solution to implement?

Did I get that right that the test files should not be put in the same
submodule (= directory tree) where the to-be-tested code lives? To me
it makes more sense when the tests and the code that is tested live in
the same submodule.